#ifndef NPSTAT_POLYFILTER1DTONUMPY_HH_
#define NPSTAT_POLYFILTER1DTONUMPY_HH_

#include "npstat/wrap/NumpyTypecode.hh"
#include "npstat/stat/AbsPolyFilter1D.hh"

namespace npstat {
    PyObject* polyFilter1DToNumpy(const PolyFilter1D& vec,
                                  const int center,
                                  const int dataLen)
    {
        const int typenum = NumpyTypecode<double>::code;
        npy_intp sh = dataLen;
        PyObject* xarr = PyArray_SimpleNew(1, &sh, typenum);
        if (xarr)
        {
            double* x = (double*)PyArray_DATA((PyArrayObject*)xarr);
            const int peak = vec.peakPosition();
            const int filterLen = vec.size();

            for (int i=0; i<dataLen; ++i)
            {
                const int idx = i + peak - center;
                if (idx >= 0 && idx < filterLen)
                    x[i] = vec[idx];
                else
                    x[i] = 0.0;
            }
        }
        return xarr;
    }
}

#endif // NPSTAT_POLYFILTER1DTONUMPY_HH_
